﻿#ifndef SYSCONFIGV2_H
#define SYSCONFIGV2_H

#include <topcore/topclassabs.h>

class QHBoxLayout;
class TUiLoader;
class TTableView;

class SysConfig : public TopClassAbs
{
    Q_OBJECT
public:
    explicit SysConfig(const QString &iModuleNameStr = QString(""),
                     const QVariantMap iUrlPars = QVariantMap(),
                     QWidget *iParent = nullptr);
    ~SysConfig();

public slots:
    void reload();
    void copy();
    void create();

    void clearData();
    void setData(const QVariantMap &iDataMap);
    QVariantMap getData() const;
    void saveData();

protected:
    void uidChangeEvent(const QString &iUidStr) override;
    void resizeEvent(QResizeEvent *iEvent) override;

private:
    TUiLoader *mUiLoader = nullptr;
    QVariantMap mDataMap = QVariantMap();
    QHBoxLayout *mBodyLayout = nullptr;
};

#endif // SYSCONFIGV2_H
