#include "syswin8desktop.h"
#include "topdesktop/topwin8desktop.h"
#include <tbaseutil/ttheme.h>

enum
{
    SysWin8Desktop_WndWidth       = 800,
    SysWin8Desktop_WndHeight      = 600,
    SysWin8Desktop_CellWidth      = 95,
    SysWin8Desktop_CellHeight     = 95,
    SysWin8Desktop_Spacing        = 20,
    SysWin8Desktop_DelayTime      = 200,
    SysWin8Desktop_ScrollBarSpace = 30,
    SysWin8Desktop_Margin         = 5
};

SysWin8Desktop::SysWin8Desktop(const QString &iModuleNameStr,
                               const QVariantMap &iUrlPars,
                               QWidget *iParent)
    : TopClassAbs(iParent)
{
    this->initModule(iModuleNameStr, iUrlPars);

    this->setAttribute(Qt::WA_TranslucentBackground);
    this->resize(SysWin8Desktop_WndWidth, SysWin8Desktop_WndHeight);
    mDesktop = new TopWin8Desktop(this);
    mDesktop->setProperty("MODULE", this->moduleName().toUpper());
    mDesktop->setState(TopDesktopItemAbs::State_None);
    mDesktop->setProperty("SS", "BODY");
    mDesktop->resize(SysWin8Desktop_WndWidth, SysWin8Desktop_WndHeight);
    setCentralWidget(mDesktop);
    connect(mDesktop, SIGNAL(urlRequested(QString, QVariant)), this, SIGNAL(openedUrl(QString, QVariant)));
    this->setAcceptDrops(true);
}

SysWin8Desktop::~SysWin8Desktop()
{
}
