﻿#ifndef SYSCONFPANEL_H
#define SYSCONFPANEL_H

#include <topcore/topclassabs.h>

class QFileSystemWatcher;
class QProcess;
class TTextEdit;

class SysModuleConfPanel : public TopClassAbs
{
    Q_OBJECT
public:
    explicit SysModuleConfPanel(const QString &iModuleNameStr = QString(""),
                          const QVariantMap &iUrlPars = QVariantMap(),
                          QWidget *iParent = nullptr);
    ~SysModuleConfPanel();

    inline void setMyRank(const QString& iRank){mRank = iRank;initWidget();}
    inline QString myRankIs(){return mRank;}
    inline void setMyType(const QString& iType){mType = iType;}
    inline QString myTypeIs(){return mType;}
    inline void setMyName(const QString& iName){mName = iName;}
    inline QString myNameIs(){return mName;}
    inline void setMyModuleName(const QString& iModuleName){mModuleName = iModuleName;}
    inline QString myModuleNameIs(){return mModuleName;}

public slots:
    void refresh();
    void setToolbarVisible(bool iVisibleBol);
    void setTextReadOnly(bool iReadOnlyBol);
    void openWithOtherProgram();
    void loadData(const QVariantMap &iDataMap);

    void saveAdmin();
    void saveDev();
    void saveProd();
    void saveProject();
    void saveUser();
    void cancelAdmin();
    void cancelDev();
    void cancelProd();
    void cancelProject();
    void cancelUser();

private slots:
    void onDataChange();

private:
    void initTextEdit();
    void initWidget();
    void save(const QString &iRankStr);
    void cancel(const QString &iRankStr);

private:
    TTextEdit *mTextEdit = nullptr;
    TTextEdit *mActTextEdit = nullptr;
    QToolBar *mToolBar = nullptr;
    QString mVersion;
    QString mRank;
    QString mType;
    QString mName;
    QString mModuleName;
    QFileSystemWatcher *mFileWatcher = nullptr;
};

#endif // SYSCONFPANEL_H
