﻿#ifndef SYSUSER_H
#define SYSUSER_H

#include <topcore/topclassabs.h>

class QHBoxLayout;
class TUiLoader;
class TTableView;

class SysUser : public TopClassAbs
{
    Q_OBJECT
public:
    explicit SysUser(const QString &iModuleNameStr = QString(""),
                     const QVariantMap &iUrlPars = QVariantMap(),
                     QWidget *iParent = nullptr);
    ~SysUser();

public slots:
    void reload();
    void copy();
    void create();

    void clearData();
    void setData(const QVariantMap &iDataMap);
    QVariantMap getData() const;
    void saveData();

    void showAddRoleDialog();

protected:
    void uidChangeEvent(const QString &iUidStr) override;
    void resizeEvent(QResizeEvent *iEvent) override;

private:
    TUiLoader *mUiLoader = nullptr;
    TTableView *mRoleTableView = nullptr;
    QHBoxLayout *mBodyLayout = nullptr;
    QStringList mProductCategoryLst;
};

#endif // SYSUSER_H
