#ifndef SYSUSERMGTV1_H
#define SYSUSERMGTV1_H

#include <tbaseutil/tdataresponse.h>
#include <tdatabaseutil/tsqlselectorv2.h>
#include <topcore/topclassabs.h>
#include "sysuserv1.h"

class TSplitter;
class TTableView;
class TopClassTableConf;
class TSearchEntry;
class TPageTool;

class SysUserMgtV1 : public TopClassAbs
{
    Q_OBJECT
public:
    explicit SysUserMgtV1(const QString &iModuleNameStr = QString(""),
                          const QVariantMap iUrlPars = QVariantMap(),
                          QWidget *iParent = nullptr);
    ~SysUserMgtV1();
public slots:
    void refresh(bool iResetPageBol = true);
    void newItem();
    bool canModify();
    QVariantList selectedItems();
    void deleteItem(const QVariantList &iIdLst);
private slots:
    void onSelectionChanged();
    void onDetailChanged();
    void onDetailSaved(const QVariant &iUidStr);
    void onNaviReset();
    void onPageChanged();
private:
    void initNaviView();
    void initTableView();
    void initDetailView();
    QStringList selectedNames();
    TSqlSelectorV2 getSqlSelector(bool iResetPageBol = true);
    QString uiloaderWhere();
    void fillTableData(const TDataResponse &iDataRes);
private:
    QStringList mProductCategoryLst;
    TSplitter *mCenterSplitter = nullptr;
    TUiLoader *mNaviView = nullptr;
    TTableView *mTableView = nullptr;
    TopClassTableConf *mTableConf;
    QWidget *mBodyWidget = nullptr;
    TSearchEntry *mSearchEntry = nullptr;
    TPageTool *mPageTool = nullptr;
    QVariantList mSelectedLst;
    SysUserV1 *mDetailView = nullptr;

};
#endif // SYSUSERMGTV1_H
