#ifndef SYSUSERV1_H
#define SYSUSERV1_H

#include <topcore/topclassabs.h>

class QHBoxLayout;
class TUiLoader;

class SysUserV1 : public TopClassAbs
{
    Q_OBJECT
public:
    explicit SysUserV1(const QString &iModuleNameStr = QString(""),
                       const QVariantMap iUrlPars = QVariantMap(),
                       QWidget *iparent = nullptr);
    ~SysUserV1();

public slots:
    void clearData();
    void setData(const QVariantMap &iDataMap);

    void create();
    void reload();

    void saveData();
    QVariantMap getData() const;

protected:
    void resizeEvent(QResizeEvent *iEvent) override;
    void uidChangeEvent(const QString &iUidStr) override;

private:
    void initCenterUi();

private:
    QHBoxLayout *mBodyLayout = nullptr;
    TUiLoader *mUiLoader = nullptr;
};

#endif // SYSUSERV1_H
